package reflect

import (
	"fmt"
	"reflect"
)

func MemberMethodCall(obj any, methodName string, in []reflect.Value) error {
	v := reflect.ValueOf(obj).Elem() // 获取指针指向的值
	t := reflect.TypeOf(obj).Elem()  // 获取指针指向的类型
	for i := 0; i < v.NumField(); i++ {
		field := v.Field(i)
		fieldType := t.Field(i)

		// 检查字段是否为 nil
		if field.IsNil() {
			return fmt.Errorf("字段 %s 为 nil，跳过\n", fieldType.Name)
		}

		// 检查是否有 methodName 方法
		method := field.MethodByName(methodName)
		if !method.IsValid() {
			//log.Println(fmt.Errorf("字段 %s 没有 %s 方法\n", fieldType.Name, methodName))
			continue
		}

		// 调用 methodName 方法
		fmt.Printf("调用 %s.%s()\n", fieldType.Name, methodName)
		method.Call(in)
	}

	return nil
}
